// 定义插件公开的成员（对象、方法、属性、事件等）
cordova.define("com.phonegap.plugins.statusBarNotification.StatusBarNotification",
    function (require, exports, module) {
        // 引入必要的类
        var exec = require("cordova/exec");
        // 创建一个JavaScript类，这个类将被公开
        var NotificationMessenger = function () {
        }

// 为NotificationMessenger类添加一个方法
        NotificationMessenger.prototype.notify = function (title, body, flag) {
            if (window.Notification) {
                this.activeNotification = new window.Notification(title, {
                    body: body,
                    flag: flag
                });
            }
        }

// 为NotificationMessenger类添加一个方法
        NotificationMessenger.prototype.clear = function () {
            if (this.activeNotification) {
                this.activeNotification.close();
                this.activeNotification = undefined;
            }
        }

        function Flag() {
        }

        Flag.FLAG_AUTO_CANCEL = "16";
        Flag.FLAG_NO_CLEAR = "32";

        /*
         * 使用W3C通知API
         */
        if (typeof window.Notification == 'undefined') {

            /**
             * Creates and shows a new notification.
             * @param title
             * @param options
             */
            window.Notification = function (title, options) {
                options = options || {};
                this.tag = options.tag || 'defaultTag';

                // Add this notification to the global index by tag.
                window.Notification.active[this.tag] = this;

                // May be undefined.
                this.onclick = options.onclick;
                this.onerror = options.onerror;
                this.onshow = options.onshow;
                this.onclose = options.onclose;

                var content = options.body || '';

                var flag = options.flag || '';

                cordova.exec(function () {
                    if (this.onshow) {
                        this.onshow();
                    }
                }, function (error) {
                    if (this.onerror) {
                        this.onerror(error);
                    }
                }, 'StatusBarNotification', 'notify', [this.tag, title, content, flag]);
            };

            // Permission is always granted on Android.
            window.Notification.permission = 'granted';

            window.Notification.requestPermission = function (callback) {
                callback('granted');
            };

            // Not part of the W3C API. Used by the native side to call onclick handlers.
            window.Notification.callOnclickByTag = function (tag) {
                console.log('callOnclickByTag');
                var notification = window.Notification.active[tag];
                if (notification && notification.onclick && typeof notification.onclick == 'function') {
                    console.log('inside if');
                    notification.onclick();
                }
            };

            // A global map of notifications by tag, so their onclick callbacks can be called.
            window.Notification.active = {};


            /**
             * Cancels a notification that has already been created and shown to the user.
             */
            window.Notification.prototype.close = function () {
                cordova.exec(function () {
                    if (this.onclose) {
                        this.onclose();
                    }
                }, function (error) {
                    if (this.onerror) {
                        this.onerror(error);
                    }
                }, 'StatusBarNotification', 'clear', [this.tag]);
            };
        }

        // 公开的对象是NotificationMessenger实例
        module.exports = new NotificationMessenger();
        window.Flag = Flag;
    });